Bug 78073 - gcc 3.2 link error
gcc 3.2 link error
Status: CLOSED CURRENTRELEASE
Product: Red Hat Raw Hide
Classification: Retired
Component: gcc3 (Show other bugs)
1.0
alpha Linux
medium Severity medium
: ---
: ---
Assigned To: Jakub Jelinek
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2002-11-18 13:42 EST by Need Real Name
Modified: 2007-04-18 12:48 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-10-03 06:44:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
readelf -Wa cpe_neural_net.o (129.96 KB, text/plain)
2002-11-20 11:17 EST, Need Real Name
no flags Details
tar of test code (65.46 KB, application/octet-stream)
2002-11-20 11:44 EST, Need Real Name
no flags Details

  None (edit)
Description Need Real Name 2002-11-18 13:42:28 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux alpha; en-US; rv:1.0rc3) Gecko/20020523

Description of problem:
Okay this is bad and I can't make a small version of the code but here is the error:

 g++ -o reg_test   reg_test.o     ../*.o ../../container/libcpe_container.a
../../math/libcpe_math.a
../cpe_neural_net.o(.rodata+0x14): relocation truncated to fit: GPREL32 *UND*
../cpe_neural_net.o(.rodata+0x18): relocation truncated to fit: GPREL32 *UND*
../cpe_neural_net.o(.rodata+0x1c): relocation truncated to fit: GPREL32 *UND*
../cpe_neural_net.o(.rodata+0x20): relocation truncated to fit: GPREL32 *UND*
../cpe_neural_net.o(.rodata+0x24): relocation truncated to fit: GPREL32 *UND*
collect2: ld returned 1 exit status

compiler:
Reading specs from /usr/lib/gcc-lib/alpha-redhat-linux/3.2/specs
Configured with: ../configure --prefix=/usr --mandir=/usr/share/man
--infodir=/usr/share/info --enable-shared --enable-threads=posix
--disable-checking --host=alpha-redhat-linux --with-system-zlib
--enable-__cxa_atexit
Thread model: posix
gcc version 3.2 20020903 (Red Hat Linux 8.0 3.2-7)

rpm data:
gcc-3.2-7
gcc-gnat-3.2-7
gcc-g77-3.2-7
libgcc-3.2-7
gcc-c++-3.2-7
gcc-objc-3.2-7
gcc-java-3.2-7
glibc-kernheaders-2.4-8.14
glibc-2.2.93-5
glibc-debug-static-2.2.93-5
glibc-debug-2.2.93-5
glibc-devel-2.2.93-5
glibc-utils-2.2.93-5
glibc-profile-2.2.93-5
glibc-common-2.2.93-5
libelf-devel-0.8.2-2
libelf-0.8.2-2



Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. can't send steps to reproduce private code 
2. Will test though.
3.
	

Additional info:
Comment 1 Jakub Jelinek 2002-11-20 04:19:02 EST
Can you send at least output of readelf -Wa ../cpe_neural_net.o?
Comment 2 Need Real Name 2002-11-20 11:17:00 EST
Created attachment 85704 [details]
readelf  -Wa cpe_neural_net.o
Comment 3 Need Real Name 2002-11-20 11:21:40 EST
upgraded compile tools again:

glibc-2.3.1-6
gcc-3.2-13
binutils-2.13.90.0.10-3

Under intel RedHat 7.2 
Reading specs from /usr/lib/gcc-lib/i386-redhat-linux/2.96/specs
gcc version 2.96 20000731 (Red Hat Linux 7.3 2.96-110)

The code compiles. According to readelf the error is somewhere in CPE_Vector
which is an template. This template passes it's regression test though.

sigh
Comment 4 Need Real Name 2002-11-20 11:44:51 EST
Created attachment 85706 [details]
tar of test code
Comment 5 Need Real Name 2002-11-20 11:47:53 EST
okay submitted code showing bug. to use:

tar -xvzf test.taz

creates an directory called test.

cd test
g++ -I . *.C

Comment 6 Need Real Name 2002-11-28 17:10:15 EST
Hello again. I have isolated the probem down to just the gcc rpm package.
I Have confirmed this by rolling back just ggc to redhat 7.1 rpms: see below

 rpm -i cpp-2.96-87.alpha.rpm gcc-2.96-87.alpha.rpm gcc-c++-2.96-87.alpha.rpm
gcc-chill-2.96-87.alpha.rpm gcc-g77-2.96-87.alpha.rpm gcc-java-2.96-87.alpha.rpm
gcc-objc-2.96-87.alpha.rpm --force

this means my setup is now:

gcc-c++-2.96-87
libstdc++-devel-2.96-87
cpp-2.96-87
gcc-g77-2.96-87
gcc-2.96-87
gcc-java-2.96-87
libstdc++-2.96-87
gcc-objc-2.96-87
gcc-chill-2.96-87
libstdc++-3.1-5
libstdc++-3.2-14
libstdc++-devel-2.96-87
libstdc++-2.96-87


and the binary now compiles. I have als had failures with other packages 
that I will now try again and will attach to this bug report. It appears
that gcc 296 (which is shipping in redhat 8.0 according to the spec file
for mozilla) will need to built as an compiler for alpha. I went looking
for that package but I can't seem to find it. (It gives gcc the name gcc296.)

Sigh

I will keep you inform, now off to try the Mesa 5.0 and mozilla 1.2

Leslie Donaldson
Comment 7 Need Real Name 2002-11-28 21:35:46 EST
well gcc 296 compiles mozilla corectly. I think the gcc problem
is in static data members that per C++ have their storage defined
outside the class.

 ls *1.2b-0_rh7.alpha.rpm
mozilla-1.2b-0_rh7.alpha.rpm
mozilla-chat-1.2b-0_rh7.alpha.rpm
mozilla-devel-1.2b-0_rh7.alpha.rpm
mozilla-dom-inspector-1.2b-0_rh7.alpha.rpm
mozilla-js-debugger-1.2b-0_rh7.alpha.rpm
mozilla-mail-1.2b-0_rh7.alpha.rpm
mozilla-nspr-1.2b-0_rh7.alpha.rpm
mozilla-nspr-devel-1.2b-0_rh7.alpha.rpm
mozilla-nss-1.2b-0_rh7.alpha.rpm
mozilla-nss-devel-1.2b-0_rh7.alpha.rpm
mozilla-psm-1.2b-0_rh7.alpha.rpm
Comment 8 Richard Henderson 2004-10-03 06:44:51 EDT
Works with gcc 3.3.4.

Note You need to log in before you can comment on or make changes to this bug.